/*
* Repetidgin by lacosox.org
* =============================
*
* Repetidgin esta formado por 2 comandos:
*
* /repetigin : permite enviar miles de veces un mismo mensaje, ahorrando al usuario
*             la necesidad de copiar y pegar el mensaje tantas veces como desee 
*             enviarlo.
*
* /nrepetidgin : identico a /repetidgin, pero cada mensaje será acompañado por un 
*		nudge, zumbido o codazo. ( este comando está disponible solo 
*		para el protocolo MSN)
*
*
* Modo de uso:
*============
*
* Desde la venta de chat ejecutar el comando :
*
* /repetidgin (Cantidad de nudges a enviar) (Mensaje que desea enviar la cantidad indicada)
* 	Ejemplo :  /repetidgin 45 maraco!  -> Será enviada 45 veces la frace "maraco!"
*
* /nrepetidgin hará lo mismo que el comando anterior, solo que en cada mensaje será 
* acompañado de un nudge (este comando estará disponible solo para el protocolo MSN).to send the same message repeatedly N times, accompanied by a Nudge, use with care
*
* 
* Versión 1.0 
* 99% en inglés
* by Danilo Lacoste
* danilo@lacosox.org
* www.lacosox.org
*
* 11 noviembre 2008
*/


#define GETTEXT_PACKAGE "gtk20"
#include <glib/gi18n-lib.h>

#define PURPLE_PLUGINS

#include <glib.h>
#include <stdio.h>  
#include <stdlib.h>  
#include <string.h>  
#include <ctype.h> 
#include <errno.h>

#include "notify.h"
#include "plugin.h"
#include "version.h"
#include "cmds.h"
#include "debug.h"


#define MSN_NUDGE 0
#define REPETIDGIN_ID "core-REPETIDGIN"
#define REPETIDGIN_NAME "Repetidgin"
#define REPETIDGIN_VERSION "1.0"
#define REPETIDGIN_CREATOR "Danilo Lacoste <danilo@lacosox.org>"
#define LACOSOX_WEBSITE "http://www.lacosox.org"
#define REPETIDGIN_DETAIL "Create the '/repetidgin' and '/nrepetidgin' commands, to send N repeat messages"
#define REPETIDGIN_DETAIL2 "Repetidgin command Plugin for pidgin by Lacosox.org"


/* grr */
#ifndef ENOTCONN
#define ENOTCONN 107
#endif

int isNumeric(const char *val)  
{  
   int i = 0, s = 0;  
   
   for(i = 0; i < strlen(val); i++)  
     if(isdigit(val[i]) == 0)  
       s = -1;  
   
   return s;  
}


/**
 * A function to send a chat or im message to the specific conversation
 * without emitting "sending-im" or "sending-chat" signal, which would
 * cause an infinite loop for this plugin.
 *
 * taken from conversation.c with signal emission removed.
 */
static void splitter_common_send(PurpleConversation *conv, const char *message, PurpleMessageFlags msgflags)
{
	PurpleConversationType type;
	PurpleAccount *account;
	PurpleConnection *gc;
	char *displayed = NULL, *sent = NULL;
	int err = 0;

	if (strlen(message) == 0)
		return;

	account = purple_conversation_get_account(conv);
	gc = purple_conversation_get_gc(conv);

	g_return_if_fail(account != NULL);
	g_return_if_fail(gc != NULL);

	type = purple_conversation_get_type(conv);

	/* Always linkfy the text for display */
	displayed = purple_markup_linkify(message);

	if ((conv->features & PURPLE_CONNECTION_HTML) &&
		!(msgflags & PURPLE_MESSAGE_RAW))
	{
		sent = g_strdup(displayed);
	}
	else
		sent = g_strdup(message);

	msgflags |= PURPLE_MESSAGE_SEND;

	if (type == PURPLE_CONV_TYPE_IM) {
		PurpleConvIm *im = PURPLE_CONV_IM(conv);

		if (sent != NULL && sent[0] != '\0') {

			err = serv_send_im(gc, purple_conversation_get_name(conv),
			                   sent, msgflags);

			if ((err > 0) && (displayed != NULL))
				purple_conv_im_write(im, NULL, displayed, msgflags, time(NULL));

			purple_signal_emit(purple_conversations_get_handle(), "sent-im-msg",
							 account,
							 purple_conversation_get_name(conv), sent);
		}
	}
	else {
		if (sent != NULL && sent[0] != '\0') {
			err = serv_chat_send(gc, purple_conv_chat_get_id(PURPLE_CONV_CHAT(conv)), sent, msgflags);

			purple_signal_emit(purple_conversations_get_handle(), "sent-chat-msg",
							 account, sent,
							 purple_conv_chat_get_id(PURPLE_CONV_CHAT(conv)));
		}
	}

	if (err < 0) {
		const char *who;
		const char *msg;

		who = purple_conversation_get_name(conv);

		if (err == -E2BIG) {
			msg = _("Unable to send message: The message is too large.");

			if (!purple_conv_present_error(who, account, msg)) {
				char *msg2 = g_strdup_printf(_("Unable to send message to %s."), who);
				purple_notify_error(gc, NULL, msg2, _("The message is too large."));
				g_free(msg2);
			}
		}
		else if (err == -ENOTCONN) {
			purple_debug(PURPLE_DEBUG_ERROR, "conversation",
					   "Not yet connected.\n");
		}
		else {
			msg = _("Unable to send message.");

			if (!purple_conv_present_error(who, account, msg)) {
				char *msg2 = g_strdup_printf(_("Unable to send message to %s."), who);
				purple_notify_error(gc, NULL, msg2, NULL);
				g_free(msg2);
			}
		}
	}

	g_free(displayed);
	g_free(sent);
}


static PurpleCmdRet
msn_cmd_NREPETIDGIN(PurpleConversation *conv, const gchar *cmd, gchar **args, gchar **error, void *data)
{
	int total=0;
	int counter=0;
	
        PurpleAccount *account = purple_conversation_get_account(conv);
        PurpleConnection *gc = purple_account_get_connection(account);
        const gchar *username;
        username = purple_conversation_get_name(conv);

	if(isNumeric(args[0]) != 0)
		{ 
		 purple_debug_info(REPETIDGIN_ID,"The argument %s is not a number\n",args[0]);
		}
 	else
 		{
		total= atoi(args[0]);
 		purple_debug_info(REPETIDGIN_ID,
 		"OK, The argument %s is a number\n To be send %s messages",args[0],args[0]);
 		
		for(counter=0; counter < total; counter++)
			{
				purple_prpl_send_attention(gc, username, MSN_NUDGE);			
				splitter_common_send(conv, args[1], PURPLE_MESSAGE_SEND);
			}
 		}

        return PURPLE_CMD_RET_OK;
}


static PurpleCmdRet
msn_cmd_REPETIDGIN(PurpleConversation *conv, const gchar *cmd, gchar **args, gchar **error, void *data)
{
	int total=0;
	int counter=0;
	
        PurpleAccount *account = purple_conversation_get_account(conv);
        PurpleConnection *gc = purple_account_get_connection(account);
        const gchar *username;
        username = purple_conversation_get_name(conv);

	if(isNumeric(args[0]) != 0)
		{ 
		 purple_debug_info(REPETIDGIN_ID,"The argument %s is not a number\n",args[0]);
		}
 	else
 		{
		total= atoi(args[0]);
 		purple_debug_info(REPETIDGIN_ID,
 		"OK, The argument %s is a number\n To be send %s messages",args[0],args[0]);
 		
		for(counter=0; counter < total; counter++)
			{
			//	purple_prpl_send_attention(gc, username, MSN_NUDGE);			
				splitter_common_send(conv, args[1], PURPLE_MESSAGE_SEND);
			}
 		}

        return PURPLE_CMD_RET_OK;
}


static gboolean plugin_load(PurplePlugin *plugin)
{

        purple_cmd_register("nrepetidgin", "ws", PURPLE_CMD_P_PRPL,
                          PURPLE_CMD_FLAG_IM | PURPLE_CMD_FLAG_PRPL_ONLY,
                         "prpl-msn", msn_cmd_NREPETIDGIN,
                          _("nrepetidgin: to send the same message repeatedly N times, accompanied by a Nudge, use with care\n usage: /nrepetidgin (a Number) (a phrase)\n by www.lacosox.org"), NULL);

        purple_cmd_register("repetidgin", "ws", PURPLE_CMD_P_PRPL,
                          PURPLE_CMD_FLAG_IM | PURPLE_CMD_FLAG_PRPL_ONLY,
                         NULL, msn_cmd_REPETIDGIN,
                          _("repetidgin: to send the same message repeatedly N times, use with care\n usage: /repetidgin (a Number) (a phrase)\n by www.lacosox.org"), NULL);


	return TRUE;
}


static PurplePluginInfo info = {
    PURPLE_PLUGIN_MAGIC,
    PURPLE_MAJOR_VERSION,
    PURPLE_MINOR_VERSION,
    PURPLE_PLUGIN_STANDARD,
    NULL,
    0,
    NULL,
    PURPLE_PRIORITY_DEFAULT,

    REPETIDGIN_ID,
    REPETIDGIN_NAME,
    REPETIDGIN_VERSION,

    REPETIDGIN_DETAIL,          
    REPETIDGIN_DETAIL2,          
    REPETIDGIN_CREATOR,                          
    LACOSOX_WEBSITE,     
    
    plugin_load,                   
    NULL,                          
    NULL,                          
                                   
    NULL,                          
    NULL,                          
    NULL,                        
    NULL,                   
    NULL,                          
    NULL,                          
    NULL,                          
    NULL                           
};                               
    
static void                        
init_plugin(PurplePlugin *plugin)
{                                  
}

PURPLE_INIT_PLUGIN(REPETIDGIN, init_plugin, info)

